#! /usr/bin/env python

import sys, subprocess

mc = sys.argv[1]
assert mc in ['/usr/local/bin/mc', '/usr/bin/mc']

mc = subprocess.Popen([mc, '--version'],
                      stdout=subprocess.PIPE,
                      stderr=subprocess.STDOUT)
mc.wait()
mc_version = mc.stdout.readline()
mc.stdout.read()
mc.stdout.close()

if mc_version.startswith('Midnight Commander'):
    mc_version = mc_version.split()[2]
elif mc_version.startswith('GNU Midnight Commander') or \
     mc_version.startswith('The Midnight Commander'):
    mc_version = mc_version.split()[3]
else:
    raise ValueError('Unknown mc version')
if '.' in mc_version:
    major, minor = [int(v) for v in mc_version.split('.')[:2]]
    if major < 4:
        print('old')
    elif (major == 4) and (minor < 6):
        print('old')
    else:
        print('new')
else:
    print('new')
